> ## Documentation Index
> Fetch the complete documentation index at: https://developers.criteo.com/llms.txt
> Use this file to discover all available pages before exploring further.

# /preview/marketing-solutions/audiences

> Updates the properties of all audiences with a valid configuration, and returns their IDs. For those that cannot be updated, one or multiple errors are returned.



## OpenAPI

````yaml https://api.criteo.com/preview/marketingsolutions/open-api-specifications.json patch /preview/marketing-solutions/audiences
openapi: 3.0.1
info:
  title: Criteo API
  description: Criteo API - MarketingSolutions
  version: Preview
servers:
  - url: https://api.criteo.com
security:
  - oauth: []
tags:
  - name: Advertiser
  - name: Analytics
  - name: Audience
  - name: Campaign
  - name: Catalog
  - name: Creative
  - name: Gateway
  - name: OnSiteRecommendation
  - name: Reco
paths:
  /preview/marketing-solutions/audiences:
    patch:
      tags:
        - Audience
      summary: /preview/marketing-solutions/audiences
      description: >-
        Updates the properties of all audiences with a valid configuration, and
        returns their IDs. For those that cannot be updated, one or multiple
        errors are returned.
      operationId: UpdateAudiences
      requestBody:
        description: ''
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/AudienceBulkUpdateInputV1'
        required: true
        x-bodyName: request
      responses:
        '200':
          description: Success or partial success
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/AudienceEntityV1ListResponse'
      security:
        - oauth:
            - MarketingSolutions_Audience_Manage
components:
  schemas:
    AudienceBulkUpdateInputV1:
      type: object
      properties:
        data:
          type: array
          items:
            $ref: '#/components/schemas/AudienceUpdateEntityV1Resource'
      description: Input to update one or more audiences.
    AudienceEntityV1ListResponse:
      type: object
      properties:
        data:
          type: array
          items:
            $ref: '#/components/schemas/AudienceEntityV1Resource'
          nullable: true
        errors:
          type: array
          items:
            $ref: '#/components/schemas/CommonProblem'
          nullable: true
          readOnly: true
        warnings:
          type: array
          items:
            $ref: '#/components/schemas/CommonProblem'
          nullable: true
          readOnly: true
      description: >-
        A top-level object that encapsulates a Criteo API response for several
        entities
    AudienceUpdateEntityV1Resource:
      type: object
      properties:
        attributes:
          $ref: '#/components/schemas/AudienceUpdateEntityV1'
        id:
          type: string
          description: Id of the entity
        type:
          type: string
      description: A class that represents a domain entity exposed by an API
    AudienceEntityV1Resource:
      type: object
      properties:
        attributes:
          $ref: '#/components/schemas/AudienceEntityV1'
        id:
          type: string
          description: Id of the entity
          nullable: true
        type:
          type: string
          nullable: true
      description: A class that represents a domain entity exposed by an API
    CommonProblem:
      type: object
      properties:
        code:
          type: string
          description: A machine-readable error code, expressed as a string value.
          nullable: true
        detail:
          type: string
          description: >-
            A human-readable explanation specific to this occurrence of the
            problem
          nullable: true
        instance:
          type: string
          description: A URI that identifies the specific occurrence of the problem.
          nullable: true
        source:
          type: object
          additionalProperties:
            type: string
          description: >-
            A machine-readable structure to reference to the exact location(s)
            causing the error(s)
          nullable: true
        stackTrace:
          type: string
          nullable: true
        title:
          type: string
          description: A short human-readable description of the problem type
          nullable: true
        traceId:
          type: string
          description: The request correlation ID this problem comes from.
          nullable: true
        traceIdentifier:
          type: string
          description: >-
            The request correlation ID this problem comes from. (deprecated, use
            traceId instead)
          nullable: true
        type:
          enum:
            - unknown
            - access-control
            - authentication
            - authorization
            - availability
            - deprecation
            - quota
            - validation
          type: string
          description: The problem's category.
          nullable: true
      description: Common problem object.
    AudienceUpdateEntityV1:
      type: object
      properties:
        algebra:
          $ref: '#/components/schemas/AlgebraNodeV1'
        description:
          $ref: '#/components/schemas/NillableString'
        name:
          type: string
          description: Name of the audience
      description: Audience of people of interest for a marketer.
      x-criteo-canonical:
        infoType: entity
        name: Audience
        version: v1
    AudienceEntityV1:
      type: object
      properties:
        adSetIds:
          uniqueItems: true
          type: array
          items:
            type: string
          description: Ad sets associated to the audience
          nullable: true
        advertiserId:
          type: string
          description: Advertiser associated to the audience
          nullable: true
        algebra:
          $ref: '#/components/schemas/AlgebraNodeV1'
        createdAt:
          type: string
          description: ISO-8601 timestamp in UTC of audience creation (read-only)
          format: date-time
          nullable: true
        description:
          type: string
          description: Description of the audience
          nullable: true
        name:
          type: string
          description: Name of the audience
          nullable: true
        updatedAt:
          type: string
          description: ISO-8601 timestamp in UTC of audience update (read-only)
          format: date-time
          nullable: true
      description: Audience of people of interest for a marketer.
      nullable: true
      x-criteo-canonical:
        infoType: entity
        name: Audience
        version: v1
    AlgebraNodeV1:
      type: object
      properties:
        and:
          type: array
          items:
            $ref: '#/components/schemas/AlgebraNodeV1'
          nullable: true
        audienceSegmentId:
          type: string
          nullable: true
        not:
          $ref: '#/components/schemas/AlgebraNodeV1'
        or:
          type: array
          items:
            $ref: '#/components/schemas/AlgebraNodeV1'
          nullable: true
      description: Node in the audience algebra definition.
      nullable: true
    NillableString:
      type: object
      properties:
        value:
          type: string
          description: >-
            The string's value. If missing or null the string's value is set to
            "null"
          nullable: true
      description: >-
        Placeholder object for string value  for which "null" is a valid
        business value
      nullable: true
  securitySchemes:
    oauth:
      type: oauth2
      flows:
        clientCredentials:
          tokenUrl: https://api.criteo.com/oauth2/token
          scopes: {}
        authorizationCode:
          authorizationUrl: https://api.criteo.com/oauth2
          tokenUrl: https://api.criteo.com/oauth2/token
          scopes: {}

````